# Розроблення вимог до системи

## Вступ
У даному розділі проводиться аналіз предметної області, пов'язаної з системою організації та управління експертними опитуваннями.
Аналіз методів експертного опитування розкриє їхні переваги та недоліки. 

Розпишемо підходи та методи організації систем організації та опитування експертів.
Ми визначимо доцільність розробки нового проєкту шляхом аналізу переваг та недоліків наявних інструментів, а також їх зіставлення з нашим майбутнім.
В глосарії опишемо основні терміни та поняття, котрі можна зустріти в сфері експертних опитувань.

У висновку сформуємо ключові аспекти, на які слід звертати увагу, щоб забезпечити успішну та ефективну реалізацію проєкту.

## Основні визначення
### Технічні визначення
**База даних** [](https://uk.wikipedia.org/wiki/База_даних)

База даних (англ. database) – сукупність даних, організованих відповідно до концепції, яка описує характеристику цих даних і взаємозв'язки між їх елементами; ця сукупність підтримує щонайменше одну з областей застосування (за стандартом ISO/IEC 2382:2015). В загальному випадку база даних містить схеми, таблиці, подання, збережені процедури та інші об'єкти. Дані у базі організовують відповідно до моделі організації даних. Таким чином, сучасна база даних, крім самих даних, містить їх опис та може містити засоби для їх обробки.

**SQL** [](https://uk.wikipedia.org/wiki/SQL)

SQL (англ. Structured query language — мова структурованих запитів) — декларативна мова програмування для взаємодії користувача з базами даних, що застосовується для формування запитів, оновлення і керування реляційними БД, створення схеми бази даних та її модифікації, системи контролю за доступом до бази даних. Сама по собі SQL не є ані системою керування базами даних, ані окремим програмним продуктом. На відміну від дійсних мов програмування (C або Pascal), SQL може формувати інтерактивні запити або, бувши вбудованою в прикладні програми, виступати як інструкції для керування даними. Окрім цього, стандарт SQL містить функції для визначення зміни, перевірки та захисту даних.

### Загальні визначення
**Опитування** [](https://uk.wikipedia.org/wiki/Опитування)

Опи́тування — це метод збору соціологічної інформації про досліджуваний об'єкт під час безпосереднього (усне опитування, інтерв'ю) або опосередкованого (письмове опитування, анкетування) спілкування того хто опитує з респондентом. Опитування бувають соціологічні, політологічні, маркетингові, психологічні — залежно від предмету дослідження. Залежно від кількості опитуваних (вибірки, вибіркової сукупності) вони також можуть бути масовими, вибірковими, індивідуальними, експертними. Також використовується для вимірювання «громадської думки» з різних питань.

**Експерт** [](https://ela.kpi.ua/server/api/core/bitstreams/8a8030cf-bfc1-4586-b197-1c7e3bf02700/content)

Експертом називають людину, що є фахівцем (спеціалістом) у певній предметній області (ПО) і може пояснити свої дії та міркування. Предметною областю називають будь-яку галузь діяльності людини, наприклад, “Технічні засоби автоматизації”, “Охорона довкілля”, “Системи штучного інтелекту” тощо.
**Експертне опитування**
Експертне опитування або опитування фахівців — це особливий метод маркетингового (і/або соціологічного) дослідження. В рамках такого опитування досліджувана тема обговорюється з експертами, компетентними в даній сфері.
### Методи експертного опитування
#### Активні методи
Активні методи передбачають спілкування між організаторами та експертами. Можливі два напрямки активної роботи з експертами: індивідуальна робота з експертом (анонімна чи відкрита) та робота з групою в цілому. 
***
#### До індивідуальних активних методів належать анкетування, інтерв’ю, діалог з експертом, ігри з експертом.

**Інтерв’ю** [](https://ela.kpi.ua/server/api/core/bitstreams/8a8030cf-bfc1-4586-b197-1c7e3bf02700/content)

Інтерв’ю – це форма спілкування між дослідником та експертом, при якій дослідник ставить заздалегідь підготовлену чергу запитань. Можна замінити ці запитання на інші у відповідності до ситуації.

**Діалог** [](https://ela.kpi.ua/server/api/core/bitstreams/8a8030cf-bfc1-4586-b197-1c7e3bf02700/content)

Діалог – це метод отримання знань у формі бесіди між дослідником та експертом, коли немає жорстко регламентованого плану проведеня і визначеного заздалегідь переліку запитань.

**Ігри з експертом** [](https://ela.kpi.ua/server/api/core/bitstreams/8a8030cf-bfc1-4586-b197-1c7e3bf02700/content)

Ігри з експертом (експертні ігри) – це експерименти, у яких фахівцю пропонують важливі ситуації з предметної області. Фахівець повинен запропонувати рішення по виходу з цих ситуацій на основі свого життєвого досвіду, спеціальних знань та уявлень.
***
#### До методів активної роботи з групою в цілому належать методи круглого столу, мозкового штурму та рольові ігри.

**Круглий стіл** [](https://ela.kpi.ua/server/api/core/bitstreams/8a8030cf-bfc1-4586-b197-1c7e3bf02700/content)

“Круглий стіл” передбачає обговорення певної проблеми, у якому приймають участь експерти з однаковими правами. Задача дискусії – вивчити проблему всебічно, тому слід запрошувати експертів, які належать до різних наукових напрямків, мають різний вік, стать і т.ін. Цей метод не передбачає терміновості прийняття рішення.

**Мозковий штурм** [](https://ela.kpi.ua/server/api/core/bitstreams/8a8030cf-bfc1-4586-b197-1c7e3bf02700/content)

“Мозковий штурм (атака)” – один із найбільш поширених методів активізації думок. Його застосовують у тих випадках, коли потрібно знайти вирішення певної проблеми за дуже короткий час. Під час такого обговоренння кожний експерт повинен запропонувати свій шлях розвязання задачі або розвинути думку іншого учасника. 

**Рольові ігри** [](https://ela.kpi.ua/server/api/core/bitstreams/8a8030cf-bfc1-4586-b197-1c7e3bf02700/content)

Рольові ігри (експертні ігри) – це експерименти, у яких колективу спеціалістів пропонують складні ситуації з предметної області. Спеціалісти у процесі відкритого обговорення приймають рішення про шляхи виходу з цих ситуацій.
***
#### Пасивні методи
До пасивних методів належать спостереження за діяльністю експертів, запис їхніх міркувань у процесі роботи (так звані *“думки вголос”*), лекції, які вони можуть прочитати. [](https://ela.kpi.ua/server/api/core/bitstreams/8a8030cf-bfc1-4586-b197-1c7e3bf02700/content)


## Підходи та способи вирішення завдання

[Методисти виділяють методи **заочного** та **очного** експертного опитування.](http://elbib.in.ua/vidi-ekspertnogo-opituvannya-metodologiya-ta-metodi-sotsiologichnih-doslidjen.html)

До методів **заочного** опитування відносять:
- письмове опитування («збір думок»);
- анкетування;
- дельфійська техніка;

До **очних** методів належать:
- «мозкова атака».

Письмове опитування (або «збір думок») – вважається найпростішим методом заочного опитування експертів. Він полягає в тому, що експертам надають спеціально підготовлені опитувальні листи, в яких вони повинні викласти свою думку по суті поставлених питань. При складанні експертного опитувальника від 50 до 90% використовуються відкриті питання. Збір думок подібний вільному інтерв'ю і відрізняється від нього лише письмовою формою опитування.

Плюси: дає можливість залучити велику кількість експертів.

Мінуси: заочний опитування пов'язане з організаційними труднощами, зумовленими низьким рівнем повернення анкет.

Анкетування – даний тип опитування може бути сформований як у відкритій, так і в закритій формі. Сильно відрізняється від письмового збору думок, оскільки спрямоване на з’ясування оцінок фахівцями тих чи інших аспектів готового рішення.

Плюси: можливість анонімного збору даних; значно спрощує можливість збору даних; стандартизація.

Мінуси: учасники можуть відмовитися від відповідей або дати неправильні відповіді через обмежену варіативність; негнучкість методу (негативна сторона стандартизованості).

Метод Дельфі – опитування експертної групи в кілька турів з узгодженням думок експертів. Суть цього методу в тому, щоб за допомогою серії послідовних дій - опитувань, інтерв'ю, мозкових штурмів - домогтися максимального консенсусу при визначенні правильного рішення. Метод передбачає опитування експертів в кілька турів (зазвичай 2-3), обробку результатів кожного туру, інформування їх про ці результати і знову повторення такої ж процедури. У першому турі відповіді даються без аргументації. Після обробки виділяються крайні і середні судження і повідомляються експертам. У другому турі опитувані знову звертаються до своїх оцінок. Так як вони мали досить часу на роздуми і дізналися про існування інших позицій з цього приводу, вони можуть переглянути свої погляди або, навпаки, посилити їх аргументацію. Після другого туру обробляються нові оцінки - крайні і середні думки узагальнюються, підсумки знову доповідають експертам. Так повторюється 3-4 рази. Практика показує, що після третього або четвертого туру думки експертів не змінюються. В ході подібної процедури виробляється узгоджена оцінка, причому дослідник не повинен нехтувати громадською думкою тих, хто після неодноразових опитувань залишився на своїй позиції.

Плюси: подібна техніка дозволяє зменшити вплив недостатньо компетентних експертів на групову оцінку, як це спостерігається при простому анкетуванні. Воно досягається за рахунок отриманої цінної інформації від більш компетентних експертів.

Мінуси: часові витрати; можливість втрати мотивації учасників.

Метод «мозкового штурму (атаки)» 

Плюси: стимулювання творчості; розширення горизонтів.
 
Мінуси: відсутність структури; можливість домінування деяких учасників.

Тепер давайте розглянемо найпопулярніші інструменти для проведення анкетувань.

[Google Forms](https://uk.wikipedia.org/wiki/Google_Форми)

Google Forms — програмне забезпечення для адміністрування опитування, 
що входить до складу безкоштовного веб-пакету Google Docs Editors, 
пропонованого Google. Послуга також включає Google Docs, Google Sheets, 
Google Slides, Google Drawings, Google Sites і Google Keep. Google Форми 
доступні лише як веб-додаток. Додаток дозволяє користувачам створювати та 
редагувати опитування в Інтернеті, співпрацюючи з іншими користувачами 
в режимі реального часу. Зібрану інформацію можна автоматично внести в 
електронну таблицю.

Цілком можливо, що Google Forms є одним із найпоширеніших конструкторів 
форм, доступних сьогодні. Враховуючи численні переваги Google Forms, 
величезна популярність програми не повинна бути несподіванкою. 

Однак, як будь-яка інша програма, Google Forms також має деякі помітні 
недоліки. 

Переваги Google Forms:
- Зручність 
- Простота використання
- Це безкоштовно
- Співпраця з колегами 
- Необмежена кількість форм
- Потужні функції (кілька типів запитань, поле завантаження файлу, умовна 
логіка)
- Кілька варіантів розповсюдження
- Частина екосистеми Google

![GoogleForms](http://139.162.162.130:16660/img/img-1.1.jpg)

[SurveyMonkey](https://en.wikipedia.org/wiki/SurveyMonkey)

SurveyMonkey - це служба як для створення простих і невеликих опитувань, 
так і для масової розсилки анкет, виявлення тенденцій і складання більших 
досліджень. Сервіс дозволяє швидко створювати опитування, налаштовувати 
їх зовнішній вигляд, змінювати місцями питання, проводити А/Б-тестування, 
вставляти опитування на сайти та соціальні мережі, складати дуже детальні 
та наочні звіти, захищати дані та інтегрувати засоби з MailChimp, 
GroSocial та іншими сервісами.

Функції, які може запропонувати сервіс:
- 51 шаблон опитувань та 15 типів питань.
- Підтримка всіх мов (Unicode).
- Логіка сторінок та питань.
- Випадковий розкид питань та конвеєрна організація.
- Користувальницькі готові теми та звіти.
- Сортування варіантів відповідей та випадковий розкид.
- Індикатор пройдених питань.
- Автонумерація сторінок та питань.
- Переадресація після завершення та сторінка подяк.
- Версія PDF для друку.
- Можливість надіслати опитування за веб-посиланням, поштою, у Twitter 
або Facebook.
- Настроювана URL-адреса.
- Можливість вставити опитування на веб-сторінку або на спливаюче вікно.
- Розсилання опитувань диспетчером.
- Підвищена безпека (SSL).
- Підсумки в режимі реального часу.
- Аналітика тексту.
- Інтеграція SPSS(пакету програм, який використовується для аналізу 
статистичних даних).
- Фільтри та перехресні таблиці відповідей за критеріями.
- Загальний доступ до відповідей.

![SurveyMonkey](http://139.162.162.130:16660/img/img-1.2.jpg)

[Responsly](https://www.responsly.com)

Responsly - платформа, яка дозволяє створювати онлайн-опитування та 
анкети всього за кілька секунд і надсилати їх тисячам одержувачів одним 
натисканням кнопки. Також є вбудована технологія штучного інтелекту, яка 
надає широкий вибір типів питань для опитувань, вибраних спеціально для 
певної аудиторії.

Функції, які може запропонувати сервіс:
- 25+ типів питань
- Автоматизація та інтеграція - планування надсилань опитувань і 
створення власних сповіщення. 
- Калькулятор - можливість обчислення балів, цін та інших змінних на 
основі відповідей людей. Створення різних кінцевих сторінок на основі 
балів.
- Багатомовні опитування.
- Безпека корпоративного рівня.

![Responsly](http://139.162.162.130:16660/img/img-1.3.jpg)

[Jotform](https://en.wikipedia.org/wiki/Jotform)

Jotform — це потужна онлайн програма, яка дозволяє будь-кому швидко 
створювати власні онлайн форми. Інтуїтивно зрозумілий інтерфейс 
конструктора форм робить створення форм неймовірно простим, без написання 
жодного рядка коду. За допомогою Jotform користувачі можуть створювати та 
публікувати форми, інтегрувати їх у свій веб-сайт та отримувати відповіді 
електронною поштою. Jotform дозволяє створювати онлайн форми, отримувати 
відповіді безпосередньо в електронних листах та створювати PDF форми для 
заповнення. 

Функції, які може запропонувати сервіс:
- Тисячі готових до використання безкоштовних шаблонів, які допоможуть 
користувачу створювати форми.
- Вбудований інструмент умовної логіки, який може показувати або 
приховувати будь-які вибрані користувачем поля форми, залежно від того, 
як люди відповідають на запитання.
- Не потрібний досвід програмування.
- Jotform дуже серйозно ставиться до безпеки даних користувачів.
- Легка інтеграція платежів.
- Інтеграція віджетів.

![Jotform](http://139.162.162.130:16660/img/img-1.4.jpg)

[QuestionPro](https://questionpro.com/)

QuestionPro — це програмне забезпечення для створення та розповсюдження 
опитувань. Воно складається з інтуїтивно зрозумілого інтерфейсу для 
створення запитань для опитувань, інструментів для їх  розповсюдження 
електронною поштою або на веб-сайті та інструментів для аналізу та 
перегляду результатів. 

Достатньо просто створити опитування та надіслати його електронною поштою 
потенційним респондентам. QuestionPro подбає про збір і запис відповідей, 
а результати будуть доступні в реальному часі.

Функції, які може запропонувати сервіс:
- Необмежена кількість опитувань.
- Необмежена кількість відповідей.
- 20+ професійних тем опитування.
- Додавання свого логотипу.
- Експорт необроблених даних.
- Цілодобова підтримка електронною поштою.
- Індекс підтримки споживача (NPS).
- Багатомовні опитування.
- Розширена логіка розгалуження.
- Мобільний додаток QuestionPro.
- Експорт SPSS (пакету програм, який використовується для аналізу 
статистичних даних).
- Цілодобовий чат і телефонна підтримка.
- Аналіз тональності тексту (клас методів контент-аналізу в комп'ютерній 
лінгвістиці, призначений для автоматизованого виявлення в текстах 
емоційно забарвленої лексики).
- Функції інтеграції опитувань.
- Функції автоматизації опитувань.
- Адміністрування опитування та функції безпеки.

![QuestionPro](http://139.162.162.130:16660/img/img-1.5.jpg)

[Fillout](https://www.fillout.com/)

Fillout — це платформа для створення форм, опитувань і тестів. Fillout 
інтегрується з інструментами, які вже використовує користувач, щоб 
допомогти автоматизувати робочі процеси та масштабувати операції. Час 
безперебійної роботи платформи та безпека додатків є двома пріоритетами 
Fillout. Для компаній із суворими вимогами щодо резидентності даних та 
іншими вимогами Fillout пропонує корпоративне рішення для безпечного 
отримання даних у будь-якому масштабі.

Функції може запропонувати сервіс:
- Fillout пропонує широкий вибір шаблонів опитувань, придатних для різних 
цілей, включаючи відгуки клієнтів, дослідження ринку, задоволеність 
працівників тощо. Кожен шаблон розроблено, щоб допомогти отримати 
користувачу цінну інформацію, і його легко налаштувати відповідно до 
потреб.
- Fillout забезпечує легку інтеграцію з різними платформами, забезпечуючи 
безпроблемну передачу та аналіз даних, які збирає користувач під час 
своїх опитувань. 
- Функція масового імпорту питань.
- Потужна інтуїтивна логіка.

![Fillout](http://139.162.162.130:16660/img/img-1.6.jpg)

## Порівняльна характеристика існуючих засобів вирішення завдання

Серед наявних наразі сервісів порівняймо ті, що були описані вище, із нашим проєктом.

Умовні позначення в таблиці порівняння:
- 🔴 засіб не відповідає критерію
- 🟡 засіб частково відповідає критерію або вимагає коштів для повноцінного функціоналу
- 🟢 засіб цілком відповідає критерію в безкоштовній версії
- ⚪ засіб частково або повністю не надав інформацію щодо критерію

| Критерій    |Xpertise (наш проєкт)|Google Forms|SurveyMonkey|Responsly|Jotform|QuestionPro|Fillout|
|:-----------:|:-------------------:|:----------:|:----------:|:-------:|:-----:|:---------:|:-----:|
|**Functionality**|                 |            |            |         |       |           |       |
|Мобільна версія| 🟢                | 🟢         | 🟢         | 🟢      | 🟢    | 🟢        | 🟢    |
|Типи відповідей| 4 шт. |⚪     |4 шт. (до 13 шт.)|⚪     |⚪|30 шт. (до 52 шт.)|40+ шт.|
|К-ть запитань в одній формі|50|безліч|10 (до безмежності)| безліч |100 (до 1 тис.)|безліч|безліч|
|К-ть форм    | 50 (до 10 тис.)     |безліч      |  безліч   |3| 5 (до 100)|10 (до безмежності)| безліч |
|Макс. к-ть опитаних|10 тис. (до 10 млн.)|безліч | 25/міс. (до 40 тис./рік) |10/міс. (до 10 тис./міс.)|100/міс. (до 10 тис./міс.)|200/форму (до 100 тис./рік)|1 тис./міс. (до 10 тис./міс.)|
|Випадкова послідовність запитань|🟢| 🔴       | €99/міс. | $79/міс. | ⚪    | 🟡        | ⚪    |
|Умовні переходи| 🟢                | 🔴       | €39/міс. | 🟡 | ⚪ | 🟡 | 🟢 |
|Квота відповідей| 🟢               | ⚪ | €432/рік | $79/міс. | ⚪ | ⚪ | ⚪ |
|Таймер закінчення опитування| 🟢 | 🟢 | ⚪ | ⚪ | ⚪ | $1188/рік | $15/місяць |
|Перегляд недозаповнених форм| 🟢 | 🔴 | ⚪ | ⚪ | ⚪ | ⚪ | $75/міс. |
|Завантаження файлів| 🟢            | 🟢       | €432/рік | ⚪ | 🟢 | ⚪ | 🟢 |
|Доступне файлове сховище| 2 Гб (до 1 Тб) | 15 Гб (до 5 Тб) | без меж | - | 100 Мб (до 100 Гб) | - | 20 Мб/файл (до 1 Гб/файл |
|**Usability**|||||||||
|Простий будівельник форм|🟢|🟢|🟢|🟢|🟢|🟢|🟢|
|AI-помічник| 🔴 | 🔴 | 🔴 | $49/міс. | 🔴 | 🔴 | 🟢 |
|Заміна брендингу на власний|🟢     | $12/міс. | €1188/рік. | $159/міс. | 🟡 | $1188/рік | $40/міс. |
|Налаштування кольорової палітри|🟢 | 🟢 | €432/рік | $159/міс. | ⚪ | $15/міс. | $40/міс. |
|Перегляд аналітики в реальному часі| 🟢 | 🟢 | 🟢 | 🟢 | 🟢 | 🟢 | 🟡 |
|**Reliability**||||||||
|Автоматичні резервні копії| 🟢 | 🟢 | 🟢 | 🟢 | 🟢 | 🟢 | 🟢 |
|Шифрування з'єднань| 🟢 | 🟢 | 🟢 | 🟢 | 🟢 | 🟢 | 🟢 |
|**Performance**||||||||
|Оптимальне використання мережі| 🟢 | 🔴 | 🟡 | 🟢 | 🔴 | 🟡 | 🟡 |
|**Supportability**||||||||
|Інструкція з використання| 🟢 | ⚪ | ⚪ | 🟢 | 🟢 | 🟢 | 🟢 |
|Онлайн-підтримка| 🟢 | $72/рік | 🟢 | 🟢 | 🟢 | 🟢 | 🟢 |

## Висновки

*[Робляться висновки щодо доцільності розробки нової або модифікації існуючої інформаційної системи, необхідності та способів інтеграції з системами(сервісами) третіх сторін, тощо.]*
